unit fuQExportDialodDemo;

interface

uses
  Forms, IB_QExportDialog, IB_Components, IB_Grid, Grids, ComCtrls,
  StdCtrls, Classes, Controls, ExtCtrls, SysUtils, IB_QExport;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    PageControl1: TPageControl;
    tshDataSet: TTabSheet;
    tshListView: TTabSheet;
    tshDBGrid: TTabSheet;
    ListView1: TListView;
    tshStringGrid: TTabSheet;
    StringGrid1: TStringGrid;
    Panel2: TPanel;
    IB_Grid1: TIB_Grid;
    IB_Grid2: TIB_Grid;
    IB_Query1: TIB_Query;
    IB_DataSource1: TIB_DataSource;
    IB_QExportDialog1: TIB_QExportDialog;
    IB_Database1: TIB_Database;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
  private
    procedure FillListView;
    procedure FillStringGrid;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  DataArray: array[0..4, 0..4] of string =
    (('1', 'ALEX', '01.05.1974', '270.36', 'true'),
     ('2', 'MARIA', '14.03.1977', '199.95', 'false'),
     ('3', 'MARK', '15.06.1976', '154.55', 'true'),
     ('4', 'JOHN', '22.08.1979', '400.12', 'true'),
     ('5', 'HELEN', '09.08.1974', '414.63', 'false'));

procedure TForm1.FormCreate(Sender: TObject);
begin
  FillListView;
  FillStringGrid;

  IB_Database1.Database := ExtractFilePath(Application.ExeName) + 'country.gdb';
  IB_Database1.Username := 'SYSDBA';
  IB_Database1.Password := 'masterkey';
  IB_Database1.Open;
  IB_Query1.Open;

  IB_QExportDialog1.FileName := ExtractFilePath(Application.ExeName) + 'demo.xls';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if IB_Query1.Active then IB_Query1.Close;
  if IB_Database1.Connected then IB_Database1.Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if PageControl1.ActivePage = tshDataSet
    then IB_QExportDialog1.ExportSource := esDataSet
    else if PageControl1.ActivePage = tshDBGrid
         then IB_QExportDialog1.ExportSource := esDBGrid
         else if PageControl1.ActivePage = tshListView
              then IB_QExportDialog1.ExportSource := esListView
              else if PageControl1.ActivePage = tshStringGrid
                   then IB_QExportDialog1.ExportSource := esStringGrid;

  IB_QExportDialog1.Execute;
end;

procedure TForm1.FillListView;
var
  I, J: Integer;
begin
  with ListView1.Items do
    for I := 0 to 4 do
      with Add do begin
        Caption := DataArray[I,0];
        for J := 1 to 4 do
          SubItems.Add(DataArray[I,J]);
      end;
end;

procedure TForm1.FillStringGrid;
var
  I, J: Integer;
begin
  with StringGrid1 do begin
    Cells[0, 0] := 'CODE';
    Cells[1, 0] := 'NAME';
    Cells[2, 0] := 'DATE';
    Cells[3, 0] := 'SALARY';
    Cells[4, 0] := 'IS_MALE';

    for I := 0 to 4 do
      for J := 0 to 4 do
        Cells[J, I + 1] := DataArray[I, J];
  end;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  if PageControl1.ActivePage = tshDataSet then
    IB_Query1.FieldsGridLabel.Clear;
  if PageControl1.ActivePage = tshDBGrid then
    IB_Query1.FieldsGridLabel.Values['POPULATION'] := 'P_O_P_U_L_A_T_I_O_N';
end;

end.
